//	aitendo I2C LN^LCD [LCD16X2-I2C] Cu
//	Rg[: SPLC792AiST7032̌݊j
//	wt]xH쎺	http://jsdiy.webcrow.jp

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include "SPLC792ALib.h"

//SPLC792A X[uAhX7bit
//Eaitendo I2C LN^LCD [LCD16X2-I2C]̏ꍇA0x3E
#define	SLAVE_ADDRESS	0x3E

//SPLC792A Rg[oCg
#define	RS_CMD	0x00
#define	RS_DATA	0x40

//1š
//EDDRAMɂ1sƂ40̃AhXÂ16\̈ƂȂĂ
#define	MAX_COLUMN_LENGTH	40

//X[uAhX(7bit)̒l
static	uint8_t SlaveAddress = (SLAVE_ADDRESS);

//Rg[oCgƃf[^oCg1𑗐M
static	void	SendByteP1(uint8_t ctrlByte, uint8_t dataByte)
{
	TWI_Start();
	TWI_SlaveAddrW(SlaveAddress);
	TWI_WriteByte(ctrlByte);
	TWI_WriteByte(dataByte);
	TWI_Stop();
	_delay_us(30);	//ߎs(26.3us)҂	ST7032̃f[^V[g
}

//Rg[oCgƃf[^oCgz𑗐M
static	void	SendByteBlock(uint8_t ctrlByte, const uint8_t* dataBytes, uint8_t length)
{
	uint8_t	i;

	TWI_Start();
	TWI_SlaveAddrW(SlaveAddress);
	TWI_WriteByte(ctrlByte);
	for (i = 0; i < length; i++) { TWI_WriteByte(dataBytes[i]); }
	TWI_Stop();
	_delay_us(30);
}

//LCDɃR}h𑗐MiڍׂHD44780Rg[̃f[^V[g̃R}hꗗQƁj
void	I2CCHARLCD_SendCmd(uint8_t cmd)
{
	SendByteP1(RS_CMD, cmd);
}

//LCDɃf[^𑗐MiڍׂHD44780Rg[̃f[^V[g̃R}hꗗQƁj
void	I2CCHARLCD_SendData(uint8_t data)
{
	SendByteP1(RS_DATA, data);
}

//ΏۂLCDfoCX؂ւ
//: X[uAhX(7bit)
//EX[uAhXقȂ铯@킪I2CoXɕڑĂꍇA
//	ǂLCDfoCX𑀍삷̂Å֐Ő؂ւB
//EI2CoXɓYfoCX1ڑĂȂꍇÅ֐Ăяoʂ͂ȂB
void	I2CCHARLCD_SlaveSelect(uint8_t sla)
{
	SlaveAddress = sla;
}

//foCX
void	I2CCHARLCD_Init()
{
	//Function Set	[bit:5]	DL=8-bit(1), N=2lines(1), DH=NormalHeight(0), *(0), IS=0(0)
	I2CCHARLCD_SendCmd(LCD_CMD_FUNCTION_SET | LCD_SUBCMD_DL8BIT | LCD_SUBCMD_2LINE);

	//Display Set	[bit:3]	D=Set Display:NO(0), C=Set Cursor:NO(0), B=Cursor Blink:NO(0)
	I2CCHARLCD_SendCmd(LCD_CMD_DISPLAY_MODE);
	
	//Clear Display
	I2CCHARLCD_Cls();
	
	//Entry Mode	[bit:2]	I/D=Increment(1), S=With Display Shift:NO(0)
	I2CCHARLCD_SendCmd(LCD_CMD_ENTRY_MODE | LCD_SUBCMD_INCREMENT);
	
	//Display Set	[bit:3]	D=Set Display:YES(1), C=Set Cursor:NO(0), B=Cursor Blink:NO(0)
	I2CCHARLCD_SendCmd(LCD_CMD_DISPLAY_MODE | LCD_SUBCMD_SET_DISPLAY);
}

//LCDʂ
void	I2CCHARLCD_Cls()
{
	I2CCHARLCD_SendCmd(LCD_CMD_CLEAR_DISPLAY);
	_delay_ms(2);
}

//z[|WVɕA
void	I2CCHARLCD_HomePos()
{
	I2CCHARLCD_SendCmd(LCD_CMD_RETURN_HOME);
	_delay_ms(2);
}

//̕\ʒuZbg
//	row_y:		0`1
//		column_x:	0`15
void	I2CCHARLCD_SetPos(uint8_t row_y, uint8_t column_x)
{
	I2CCHARLCD_SendCmd(LCD_CMD_SET_DDRAM_ADRS | (row_y * 0x40 + column_x));
}

//1\
void	I2CCHARLCD_PutChar(char cc)
{
	I2CCHARLCD_SendData(cc);
}

//\
void	I2CCHARLCD_PutString(const char* str)
{
	uint8_t length;
	for (length = 0; length < MAX_COLUMN_LENGTH && str[length] != '\0'; length++) { }
	SendByteBlock(RS_DATA, (uint8_t*)str, length);
}

//vÖɊi[ꂽ\
//ĂяoF	I2CCHARLCD_PutStringP(PSTR("Hello World!!"));
void	I2CCHARLCD_PutStringP(const char* strpgm)
{
	uint8_t i, cc;
	
	TWI_Start();
	TWI_SlaveAddrW(SlaveAddress);
	TWI_WriteByte(RS_DATA);
	
	for (i = 0; i < MAX_COLUMN_LENGTH; i++)
	{
		cc = pgm_read_byte(strpgm++);
		if (cc == '\0') break;
		TWI_WriteByte(cc);
	}
	
	TWI_Stop();
	_delay_us(30);
}

//Ȃ\i10ij	8bit/16bitp
#define I2CCHARLCD_UINT16_BUFSIZE	6	//"65535"ōő5 { '\0'
void	I2CCHARLCD_PutUInt(uint16_t n)
{
	char nums[I2CCHARLCD_UINT16_BUFSIZE];
	int8_t i = I2CCHARLCD_UINT16_BUFSIZE - 1;	//z񖖔̃CfbNXŏ
	
	nums[i] = '\0';
	
	do
	{
		nums[--i] = '0' + n % 10;
		n /= 10;
	}
	while (n != 0);
	
	I2CCHARLCD_PutString(&nums[i]);
}

//萮\i10ij	8bit/16bitp
void	I2CCHARLCD_PutInt(int16_t n)
{
	if (n < 0)
	{
		I2CCHARLCD_PutChar('-');
		I2CCHARLCD_PutUInt(-n);
	}
	else
	{
		I2CCHARLCD_PutUInt(n);
	}
}

//0l߂16i\
//Eړ'0x'ڔ'h'͕tȂ
//E'keta'I2CCHARLCD_WORD_BUFSIZEł̂Ƃ
#define I2CCHARLCD_WORD_BUFSIZE	5	//"FFFF"ōő4 { '\0'
static	void	PutHex(uint16_t n, uint8_t keta)
{
	char nums[I2CCHARLCD_WORD_BUFSIZE];
	int8_t i;
	uint8_t hex;
	
	nums[keta] = '\0';

	for (i = keta - 1; 0 <= i; i--)
	{
		hex = n & 0x0F;
		nums[i] = (hex < 10) ? ('0' + hex) : ('A' + hex - 10);
		n >>= 4;
	}

	I2CCHARLCD_PutString(nums);
}

//0l216i\
void	I2CCHARLCD_PutByte(uint8_t n)
{
	PutHex(n, 2);
}

//0l416i\
void	I2CCHARLCD_PutWord(uint16_t n)
{
	PutHex(n, 4);
}

//[U[`Zbg
//E̊֐ĂяoI2CCHARLCD_SetPos()ŕ\ʒuw肷邱ƁB
//id:	0-7iLN^R[hj
//dots:	uint8_t[8]i5x8̃hbgp^[j
void	I2CCHARLCD_DefChar(uint8_t id, const uint8_t* dots)
{
	uint8_t	i;
	
	for (i = 0; i < 8; i++)
	{
		I2CCHARLCD_SendCmd(LCD_CMD_SET_CGRAM_ADRS | (id << 3) | i);
		I2CCHARLCD_SendData(dots[i]);
	}
}
