//	aitendo I2C LN^LCD [LCD16X2-I2C] eXgvO
//	Rg[: SPLC792AiST7032̌݊j
//	wt]xH쎺	http://jsdiy.webcrow.jp

/*
y|[gΉz	ATmega328P	x:݂Ȃ(PC6RESET) -:
bit		7	6	5	4	3	2	1	0
portB	-	-	-	-	-	-	-	-		--
portC	x	x	SCL	SDA	RST	-	-	-		TWI(I2C), LCD-Reset
portD	-	-	-	-	-	-	-	-		--

yATmega328Pz
|CCCCCC---BBBBB|
|543210GRV54321|
>              |
|601234VG675670|
|CDDDDD--BBDDDB|

yq[Yrbgz(ftavrw.exe -rf)	Hoאݒ Low:01100010(62), Hi:11011111(D9)
Low: 11100010 (E2)
     ||||++++-- CKSEL[3:0] VXeNbNI
     ||++-- SUT[1:0] N
     |+-- CKOUT (0:PB0ɃVXeNbNo)
     +-- CKDIV8 NbNl (1:1/1, 0:1/8)

High:11-11001 (D9)
     |||||||+-- BOOTRST f[^V[gQ
     |||||++-- BOOTSZ[1:0] f[^V[gQ
     ||||+-- EESAVE (EEPROM 1:, 0:ێ)
     |||+-- WDTON (1:WDTʏ퓮, 0:WDT펞ON)
     ||+-- SPIEN (1:ISP֎~, 0:ISP) Parallel̂
     |+-- DWEN (On-ChipfobO 1:, 0:L)
     +-- RSTDISBL (RESETs 1:L, 0:(PC6))

Ext: -----111 (FF)
          +++-- BODLEVEL[2:0] (111:, 110:1.8V, 101:2.7V, 100:4.3V)

yrhz
Atmel Studio 6 (Version: 6.2.1502 - Service Pack 1)
AVR8_Toolchain_Version:3.4.5.1522 GCC_VERSION:4.8.1
ATmega328P	8MHzi8MHz/Ȃj

yXVz
2015/08/23	v0.01	JJn
	uI2cLcdMastervvWFNgRs[ArhB
	Program Memory Usage 	:	814 bytes   2.5 % Full
	Data Memory Usage 		:	8 bytes   0.4 % Full
	
2015/09/05	v1.00	
	Program Memory Usage 	:	1226 bytes   3.7 % Full
	Data Memory Usage 		:	66 bytes   3.2 % Full
*/

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include "SPLC792ALib.h"

//[U[`
const	uint8_t	dots[][8] =
{
	{	//
		0b01111,
		0b01001,
		0b01111,
		0b01001,
		0b01111,
		0b01001,
		0b10001,
		0b00000
	},
	{	//
		0b00100,
		0b10101,
		0b10101,
		0b00100,
		0b01010,
		0b01010,
		0b10001,
		0b00000
	},
	{	//
		0b00100,
		0b00101,
		0b11110,
		0b00110,
		0b01101,
		0b10100,
		0b00100,
		0b00000
	},
	{	//
		0b00100,
		0b00100,
		0b11111,
		0b00100,
		0b01110,
		0b10101,
		0b00100,
		0b00000
	},
	{	//
		0b01110,
		0b10001,
		0b01110,
		0b11111,
		0b00100,
		0b10101,
		0b11111,
		0b00000
	},
	{	//y
		0b00100,
		0b00100,
		0b11111,
		0b00100,
		0b00100,
		0b00100,
		0b11111,
		0b00000
	},
	{	//
		0b11111,
		0b10001,
		0b10001,
		0b11111,
		0b10001,
		0b10001,
		0b11111,
		0b00000
	},
	{	//N
		0b10000,
		0b11111,
		0b00100,
		0b11111,
		0b10100,
		0b11111,
		0b00100,
		0b00000
	}
};

//LCDZbg
void	I2CCHARLCD_Reset()
{
	uint8_t resetPinBV = (1 << PORTC3);
	
	DDRC = resetPinBV;
	PORTC = ~resetPinBV;
	_delay_ms(1);
	PORTC = resetPinBV;
	_delay_ms(1);
}

int main(void)
{
	uint8_t i;
	
	_delay_ms(200);	//X[ufoCX(I2C-LCD)̗オ҂
	
	TWI_BusSpeed(TWI_BUSSPEED_CPU8MHz_SCL100kHz);	//AVRTWI֘AWX^ݒ肷
	I2CCHARLCD_Reset();
	I2CCHARLCD_Init();

	for (i = 0; i < 8; i++) { I2CCHARLCD_DefChar(i, dots[i]); }
	
	I2CCHARLCD_SetPos(0, 0);
	I2CCHARLCD_PutStringP(PSTR("Hello World!!"));
	I2CCHARLCD_PutChar(' ');
	I2CCHARLCD_PutByte(0xEF);
	
	I2CCHARLCD_SetPos(1, 0);
	for (i = 0; i < 8; i++) { I2CCHARLCD_PutChar(i); }
	I2CCHARLCD_PutChar(' ');
	I2CCHARLCD_PutInt(-32768);
	I2CCHARLCD_PutChar('*');

	//ȉAlXȕ\eXg
	//I2CCHARLCD_PutChar('A');
	//I2CCHARLCD_PutStringP(PSTR("Hello World!!"));
	//I2CCHARLCD_PutUInt(65535);
	//I2CCHARLCD_PutInt(-32768);
	/*
	I2CCHARLCD_PutByte(0xEF);
	I2CCHARLCD_PutChar('!');
	I2CCHARLCD_PutWord(0x1A2B);
	I2CCHARLCD_PutChar('!');
	I2CCHARLCD_PutByte(0xE);
	I2CCHARLCD_PutChar('!');
	I2CCHARLCD_PutWord(0xC4D);
	*/
	
	return 0;
}
