//	TWI(I2C){색Cui}X^[pj
//	wt]xH쎺	http://jsdiy.webcrow.jp
/*
yXVz
2013/09/27	v1.00	
2014/01/06	v1.10	TWI_BusSpeed(),TWI_BusSpeedReg()ǉ
2015/09/05	v1.20	TWI_SlaveAddrW(),TWI_SlaveAddrR()ŁA
					u(AhX7bit){(1bit)ō\ꂽ8bit̒lv
					uAhX7bitv֕ύXA֐1rbgVtg邱ƂƂ
*/

#include <avr/io.h>
#include "twilib.h"

enum E_TWI_StatusCode
{
	STM_START		= 0x08,	//A START condition has been transmitted
	STM_REPEAT		= 0x10,	//A repeated START condition has been transmitted
	
	//Master Transmitter Mode
	STMT_SLAW_ACK	= 0x18,	//SLA+W has been transmitted; ACK has been received
	STMT_SLAW_NACK	= 0x20,	//SLA+W has been transmitted; NOT ACK has been received
	STMT_DATA_ACK	= 0x28,	//Data byte has been transmitted; ACK has been received
	STMT_DATA_NACK	= 0x30,	//Data byte has been transmitted; NOT ACK has been received
	STMT_ARBI_LOST	= 0x38,	//Arbitration lost in SLA+W or data bytes
	
	//Master Receiver Mode
	STMR_ARBI_LOST	= 0x38,	//Arbitration lost in SLA+R or NOT ACK bit
	STMR_SLAR_ACK	= 0x40,	//SLA+R has been transmitted; ACK has been received
	STMR_SLAR_NACK	= 0x48,	//SLA+R has been transmitted; NOT ACK has been received
	STMR_DATA_ACK	= 0x50,	//Data byte has been received; ACK has been returned
	STMR_DATA_NACK	= 0x58,	//Data byte has been received; NOT ACK has been returned
	
	//Miscellaneous States
	STM_NOTHING		= 0xF8,	//No relevant state information available; TWINT = "0"
	STM_BUS_ERROR	= 0x00	//Bus error due to an illegal START or STOP condition
	
	/*
	//Slave Receiver Mode
	STSR_SLAW_ACK	= 0x60,	//Own SLA+W has been received; ACK has been returned
	STSR_ARBI_LOST_SLAW_ACK	= 0x68,	//Arbitration lost in SLA+R/W as Master; own SLA+W has been received; ACK has been returned
	STSR_GENERALCALL_ACK	= 0x70,	//General call address has been received; ACK has been returned
	STSR_ARBI_LOST_GENERALCALL_ACK	= 0x78,	//Arbitration lost in SLA+R/W as Master; General call address has been received; ACK has been returned
	STSR_PREV_ADDR_SLAW_ACK	= 0x80,	//Previously addressed with own SLA+W; data has been received; ACK has been returned
	STSR_PREV_ADDR_SLAW_NACK	= 0x88,	//Previously addressed with own SLA+W; data has been received; NOT ACK has been returned
	STSR_PREV_ADDR_GENERALCALL_ACK	= 0x90,	//Previously addressed with general call; data has been received; ACK has been returned
	STSR_PREV_ADDR_GENERALCALL_NACK	= 0x98,	//Previously addressed with general call; data has been received; NOT ACK has been returned
	STSR_STOP	= 0xA0,	//A STOP condition or repeated START condition has been received while still addressed as Slave
	
	//Slave Transmitter Mode
	STST_SLAR	= 0xA8,	//Own SLA+R has been received;
	STST_ARBI_LOST_SLAR_ACK	= 0xB0,	// Arbitration lost in SLA+R/W as Master; own SLA+R has been received; ACK has been returned
	STST_DATA_ACK	= 0xB8,	//Data byte in TWDR has been transmitted; ACK has been received
	STST_DATA_NACK	= 0xC0,	//Data byte in TWDR has been transmitted; NOT ACK has been received
	STST_LASTDATA_ACK	= 0xC8	//Last data byte in TWDR has been transmitted (TWEA = g0h); ACK has been received
	*/
};

#define Status	(TWSR & 0xF8)
#define SLA_W_BIT	0
#define SLA_R_BIT	1

//I2C̃oXXs[h(SCL)Zbg
//EvZbglw肷B
void	TWI_BusSpeed(ETwiBusSpeed speed)
{
	switch (speed)
	{
	case TWI_BUSSPEED_CPU1MHz_SCL62500Hz:
		if (F_CPU == 1000000UL) TWI_BusSpeedReg(0, 0);
		break;
		
	case TWI_BUSSPEED_CPU8MHz_SCL100kHz:
		if (F_CPU == 8000000UL) TWI_BusSpeedReg(32, 0);
		break;
		
	case TWI_BUSSPEED_CPU8MHz_SCL400kHz:
		if (F_CPU == 8000000UL) TWI_BusSpeedReg(2, 0);
		break;
		
	default:	break;
	}
	
	/*
	F_CPU=1MHzTWBR=0,TWSR=0b00̂ƂSCL=62500HziF_CPU=1MHzɂőݒj
	TWBR = 0;
	TWSR = 0;
	
	F_CPU=8MHzSCL=100kHz̐ݒ
	TWBR = (8MHz / 100kHz - 16) / (2 * prescale) = 64 / (2 * 1) = 32, prescale=1
	TWBR = 32;
	TWSR = 0;

	F_CPU=8MHzSCL=400kHz̐ݒ
	TWBR = (8MHz / 400kHz - 16) / (2 * prescale) = 4 / (2 * 1) = 2, prescale=1
	TWBR = 2;
	TWSR = 0;
	*/
}

//I2C̃oXXs[h(SCL)Zbg
//EŌvZlWX^ɑB
void	TWI_BusSpeedReg(uint8_t valueTWBR, uint8_t valueTWSR)
{
	TWBR = valueTWBR;
	TWSR = valueTWSR;
	
	/*
	TWI(I2C)̃WX^ݒ肷
	vZ:
		TWBR = (F_CPU / scl - 16) / (2 * prescale)
		TWSR:TWPS1,0 = 00:1, 01:4, 10:16, 11:64
	:
		TWBR = (8MHz / 400kHz - 16) / (2 * prescale) = 4 / (2 * 1) = 2, prescale=1
		TWSR = (0b00 << TWPS0)
	*/
}

//X^[g𑗐M
//߂l	0:, 0:s
uint8_t	TWI_Start()
{
	TWCR = (1 << TWINT) | (1 << TWSTA) | (1 << TWEN);
	while (!(TWCR & (1 << TWINT))) { }
	return (Status == STM_START || Status == STM_REPEAT);
}

//oXG[mFƑΉ
static	void	BusErrorCheck()
{
	//oXG[ TWCR:TWINT=1, TWCR:TWSTO=1 ƂiXgbv𑗐M΂悢j
	if (Status == STM_BUS_ERROR) { TWI_Stop(); }
}

//X[ufoCX̃AhX^Cӂ̃f[^𑗐M
//߂l:	Xe[^X
static	uint8_t	MasterTransmit(uint8_t byteValue)
{
	TWDR = byteValue;
	TWCR = (1 << TWINT) | (1 << TWEN);
	while (!(TWCR & (1 << TWINT))) { }
	BusErrorCheck();
	return Status;
}

//X[ufoCX̃AhXw肷Fݕ
//:	X[uAhX7bit
//߂l	0:, 0:s
uint8_t	TWI_SlaveAddrW(uint8_t sla)
{
	return (MasterTransmit((sla << 1) | SLA_W_BIT) == STMT_SLAW_ACK);
}

//X[ufoCX̃AhXw肷Fǂݍݕ
//:	X[uAhX7bit
//߂l	0:, 0:s
uint8_t	TWI_SlaveAddrR(uint8_t sla)
{
	return (MasterTransmit((sla << 1) | SLA_R_BIT) == STMR_SLAR_ACK);
}

//f[^𑗐M
//߂l	0:, 0:s
uint8_t	TWI_WriteByte(uint8_t data)
{
	return (MasterTransmit(data) == STMT_DATA_ACK);
}

//f[^M
//	retAck:	1:ACKԂ, 0:NACKԂ
//		data: ǂݍ񂾒li[
//߂l	0:, 0:s
//
//yFI2C-EEPROM̃V[PVǂݍ݁z
//E ACKԂc f[^1MAĎ̃f[^vꍇB
//ENACKԂc f[^1MĊꍇiɃXgbv𑗐MjB
uint8_t	TWI_ReadByte(uint8_t retAck, uint8_t* data)
{
	//X[u̓߂
	//Ẽf[^M̂Ǝf[^v邩iACKԂjA
	//	͏Iʒm邩iNACKԂjAw肷B
	TWCR = (1 << TWINT) | (retAck << TWEA) | (1 << TWEN);
	while (!(TWCR & (1 << TWINT))) { }
	BusErrorCheck();
	
	//Ml擾
	//EM̐ۂɂ炸WX^̒l擾B
	*data = TWDR;
	
	return (Status == (retAck ? STMR_DATA_ACK : STMR_DATA_NACK));	//M̐ۂ͂Ŕ肳
}

//Xgbv𑗐M
void	TWI_Stop()
{
	TWCR = (1 << TWINT) | (1 << TWSTO) | (1 << TWEN);
}
